/* www.N-Modellbahn.de
  Created by S.Schwarz
   Track occupancy indicator with INPUT_PULL V01 (Release 03.05.2019)
*/

// ********************** PIN Definition ********************

// Definition of output PINs for occupancy indication LEDs:
const int Led_outTrack1 = 0;                    // the number of indicator output LED pin Track 1
const int Led_outTrack2 = 1;                    // the number of indicator output LED pin Track 2
const int Led_outTrack3 = 2;                    // the number of indicator output LED pin Track 3
const int Led_outTrack4 = 3;                    // the number of indicator output LED pin Track 4
const int Led_outTrack5 = 4;                    // the number of indicator output LED pin Track 5
const int Led_outTrack6 = 5;                    // the number of indicator output LED pin Track 6
const int Led_outTrack7 = 6;                    // the number of indicator output LED pin Track 7

// Definition of input Track PINs for occupancy indicatore control
const int Indicator_inTrack1 = 7;               // the number of Indicator input pin Track 1
const int Indicator_inTrack2 = 8;               // the number of Indicator input pin Track 2
const int Indicator_inTrack3 = 9;               // the number of Indicator input pin Track 3
const int Indicator_inTrack4 = 10;              // the number of Indicator input pin Track 4
const int Indicator_inTrack5 = 11;              // the number of Indicator input pin Track 5
const int Indicator_inTrack6 = 12;              // the number of Indicator input pin Track 6
const int Indicator_inTrack7 = 13;              // the number of Indicator input pin Track 7

// ************ Variablen Definition for reading & storing occupancy status ************

// variables for reading & storing occupancy status Track 1:
int Indicator_stTrack1Act;                     // variable for reading the actual Track 1 indicator status
int Indicator_stTrack1Pre = HIGH;              // variable to store the previous Track 1 indicator status
int Indicator_stTrack1 = LOW;                  // variable to store the Track 1 indicator status

// variables for reading & storing occupancy status Track 2:
int Indicator_stTrack2Act;                     // variable for reading the actual Track 2 indicator status
int Indicator_stTrack2Pre = HIGH;              // variable to store the previous Track 2 indicator status
int Indicator_stTrack2 = LOW;                  // variable to store the Track 2 indicator status

// variables for reading & storing occupancy status Track 3:
int Indicator_stTrack3Act;                     // variable for reading the actual Track 3 indicator status
int Indicator_stTrack3Pre = HIGH;              // variable to store the previous Track 3 indicator status
int Indicator_stTrack3 = LOW;                  // variable to store the Track 3 indicator status

// variables for reading & storing occupancy status Track 4:
int Indicator_stTrack4Act;                     // variable for reading the actual Track 4 indicator status
int Indicator_stTrack4Pre = HIGH;              // variable to store the previous Track 4 indicator status
int Indicator_stTrack4 = LOW;                  // variable to store the Track 4 indicator status

// variables for reading & storing occupancy status Track 5:
int Indicator_stTrack5Act;                     // variable for reading the actual Track 5 indicator status
int Indicator_stTrack5Pre = HIGH;              // variable to store the previous Track 5 indicator status
int Indicator_stTrack5 = LOW;                  // variable to store the Track 5 indicator status

// variables for reading & storing occupancy status Track 6:
int Indicator_stTrack6Act;                     // variable for reading the actual Track 6 indicator status
int Indicator_stTrack6Pre = HIGH;              // variable to store the previous Track 6 indicator status
int Indicator_stTrack6 = LOW;                  // variable to store the Track 6 indicator status

// variables for reading & storing occupancy status Track 7:
int Indicator_stTrack7Act;                     // variable for reading the actual Track 7 indicator status
int Indicator_stTrack7Pre = HIGH;              // variable to store the previous Track 7 indicator status
int Indicator_stTrack7 = LOW;                  // variable to store the Track 7 indicator status

// ************ Variablen Definition for reading occupancy indication LED status ************

// variables for reading occupancy idnication LED status:
int Led_stTrack1 = HIGH;                    // variable for reading the Track 1 LED pin
int Led_stTrack2 = HIGH;                    // variable for reading the Track 2 LED pin
int Led_stTrack3 = HIGH;                    // variable for reading the Track 3 LED pin
int Led_stTrack4 = HIGH;                    // variable for reading the Track 4 LED pin
int Led_stTrack5 = HIGH;                    // variable for reading the Track 5 LED pin
int Led_stTrack6 = HIGH;                    // variable for reading the Track 6 LED pin
int Led_stTrack7 = HIGH;                    // variable for reading the Track 7 LED pin

// **********************Variables for timers********************

// variables for reading the millis () value
unsigned long  Time_tilast1 = 0;               // variable for reading the millis value Track 1
unsigned long  Time_tilast2 = 0;               // variable for reading the millis value Track 2
unsigned long  Time_tilast3 = 0;               // variable for reading the millis value Track 3
unsigned long  Time_tilast4 = 0;               // variable for reading the millis value Track 4
unsigned long  Time_tilast5 = 0;               // variable for reading the millis value Track 5
unsigned long  Time_tilast6 = 0;               // variable for reading the millis value Track 6
unsigned long  Time_tilast7 = 0;               // variable for reading the millis value Track 7

// ********************** Defintiation of Debouncting time ********************

unsigned long DebouncingTime = 200;              // Debouncing time duration

void setup() {

  // initialize the occupancy Track pin´s as an input:
  pinMode(Indicator_inTrack1, INPUT_PULLUP);
  pinMode(Indicator_inTrack2, INPUT_PULLUP);
  pinMode(Indicator_inTrack3, INPUT_PULLUP);
  pinMode(Indicator_inTrack4, INPUT_PULLUP);
  pinMode(Indicator_inTrack5, INPUT_PULLUP);
  pinMode(Indicator_inTrack6, INPUT_PULLUP);
  pinMode(Indicator_inTrack7, INPUT_PULLUP);

  // initialize the occupancy indication LED pins as an output:
  pinMode(Led_outTrack1, OUTPUT);
  pinMode(Led_outTrack2, OUTPUT);
  pinMode(Led_outTrack3, OUTPUT);
  pinMode(Led_outTrack4, OUTPUT);
  pinMode(Led_outTrack5, OUTPUT);
  pinMode(Led_outTrack6, OUTPUT);
  pinMode(Led_outTrack7, OUTPUT);

}

void loop() {
// ########### read the state of the occopancy indicator Track pint: ###########

  Indicator_stTrack1Act = digitalRead(Indicator_inTrack1);
  Indicator_stTrack2Act = digitalRead(Indicator_inTrack2);
  Indicator_stTrack3Act = digitalRead(Indicator_inTrack3);
  Indicator_stTrack4Act = digitalRead(Indicator_inTrack4);
  Indicator_stTrack5Act = digitalRead(Indicator_inTrack5);
  Indicator_stTrack6Act = digitalRead(Indicator_inTrack6);
  Indicator_stTrack7Act = digitalRead(Indicator_inTrack7);

// ################### Indicator control Track 1: ####################

  if (Indicator_stTrack1Act != Indicator_stTrack1Pre) {               // check if status of occopancy on Track 1 has changed
    Time_tilast1 = millis();                                          // Write actual time in Time_tilast1
    }
  if ((millis() - Time_tilast1) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
      if (Indicator_stTrack1Act != Indicator_stTrack1) {              // check if occopancy status change of Track 1 is still present after debouncing time 
          Indicator_stTrack1 = Indicator_stTrack1Act;
      
         if (Indicator_stTrack1 == LOW) {                             // check if Track 1 is occupied
            Led_stTrack1 = HIGH;                                      // switch ON the indicator LED for Track 1
        }
        if (Indicator_stTrack1 == HIGH) {                             // check if Track 1 is free
            Led_stTrack1 = LOW;                                       // switch OFF the indicator LED for Track 1      
      }
    }
  }
  digitalWrite(Led_outTrack1, Led_stTrack1);                          //write the LED Status for Track 1 indicator LED
  Indicator_stTrack1Pre = Indicator_stTrack1Act;                      //write current Track status in previous Track statu variable

// ################### Indicator control Track 2: ####################

 if (Indicator_stTrack2Act != Indicator_stTrack2Pre) {               // check if status of occopancy on Track 2 has changed
    Time_tilast2 = millis();                                          // Write actual time in Time_tilast2
  }
  if ((millis() - Time_tilast2) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
    if (Indicator_stTrack2Act != Indicator_stTrack2) {                // check if occopancy status change of Track 2 is still present after debouncing time 
      Indicator_stTrack2 = Indicator_stTrack2Act;
      if (Indicator_stTrack2 == LOW) {                                 //check if Track 2 is occupied
        Led_stTrack2 = HIGH;                                          // switch ON the indicator LED for Track 2
      }
      if (Indicator_stTrack2 == HIGH) {                                //check if Track 2 is free
        Led_stTrack2 = LOW;                                           // switch OFF the indicator LED for Track 2
      }
    }
  }
  digitalWrite(Led_outTrack2, Led_stTrack2);                          //write the LED Status for Track 2 indicator LED
  Indicator_stTrack2Pre = Indicator_stTrack2Act;                      //write current Track status in previous Track statu variable  

// ################### Indicator control Track 3: ####################

 if (Indicator_stTrack3Act != Indicator_stTrack3Pre) {               // check if status of occopancy on Track 3 has changed
    Time_tilast3 = millis();                                          // Write actual time in Time_tilast3
  }
  if ((millis() - Time_tilast3) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
    if (Indicator_stTrack3Act != Indicator_stTrack3) {                // check if occopancy status change of Track 3 is still present after debouncing time 
      Indicator_stTrack3 = Indicator_stTrack3Act;
      if (Indicator_stTrack3 == LOW) {                                 //check if Track 3 is occupied
        Led_stTrack3 = HIGH;                                          // switch ON the indicator LED for Track 3
      }
      if (Indicator_stTrack3 == HIGH) {                                //check if Track 3 is free
        Led_stTrack3 = LOW;                                           // switch OFF the indicator LED for Track 3
      }
    }
  }
  digitalWrite(Led_outTrack3, Led_stTrack3);                          //write the LED Status for Track 3 indicator LED
  Indicator_stTrack3Pre = Indicator_stTrack3Act;                      //write current Track status in previous Track statu variable  

// ################### Indicator control Track 4: ####################

 if (Indicator_stTrack4Act != Indicator_stTrack4Pre) {               // check if status of occopancy on Track 4 has changed
    Time_tilast4 = millis();                                          // Write actual time in Time_tilast4
  }
  if ((millis() - Time_tilast4) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
    if (Indicator_stTrack4Act != Indicator_stTrack4) {                // check if occopancy status change of Track 4 is still present after debouncing time 
      Indicator_stTrack4 = Indicator_stTrack4Act;
      if (Indicator_stTrack4 == LOW) {                                 //check if Track 4 is occupied
        Led_stTrack4 = HIGH;                                          // switch ON the indicator LED for Track 4
      }
      if (Indicator_stTrack4 == HIGH) {                                //check if Track 4 is free
        Led_stTrack4 = LOW;                                           // switch OFF the indicator LED for Track 4
      }
    }
  }
  digitalWrite(Led_outTrack4, Led_stTrack4);                          //write the LED Status for Track 4 indicator LED
  Indicator_stTrack4Pre = Indicator_stTrack4Act;                      //write current Track status in previous Track statu variable 

// ################### Indicator control Track 5: ####################

 if (Indicator_stTrack5Act != Indicator_stTrack5Pre) {               // check if status of occopancy on Track 5 has changed
    Time_tilast5 = millis();                                          // Write actual time in Time_tilast5
  }
  if ((millis() - Time_tilast5) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
    if (Indicator_stTrack5Act != Indicator_stTrack5) {                // check if occopancy status change of Track 5 is still present after debouncing time 
      Indicator_stTrack5 = Indicator_stTrack5Act;
      if (Indicator_stTrack5 == LOW) {                                 //check if Track 5 is occupied
        Led_stTrack5 = HIGH;                                          // switch ON the indicator LED for Track 5
      }
      if (Indicator_stTrack5 == HIGH) {                                //check if Track 5 is free
        Led_stTrack5 = LOW;                                           // switch OFF the indicator LED for Track 5
      }
    }
  }
  digitalWrite(Led_outTrack5, Led_stTrack5);                          //write the LED Status for Track 5 indicator LED
  Indicator_stTrack5Pre = Indicator_stTrack5Act;                      //write current Track status in previous Track statu variable 

  // ################### Indicator control Track 6: ####################

 if (Indicator_stTrack6Act != Indicator_stTrack6Pre) {               // check if status of occopancy on Track 6 has changed
    Time_tilast6 = millis();                                          // Write actual time in Time_tilast6
  }
  if ((millis() - Time_tilast6) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
    if (Indicator_stTrack6Act != Indicator_stTrack6) {                // check if occopancy status change of Track 6 is still present after debouncing time 
      Indicator_stTrack6 = Indicator_stTrack6Act;
      if (Indicator_stTrack6 == LOW) {                                 //check if Track 6 is occupied
        Led_stTrack6 = HIGH;                                          // switch ON the indicator LED for Track 6
      }
      if (Indicator_stTrack6 == HIGH) {                                //check if Track 6 is free
        Led_stTrack6 = LOW;                                           // switch OFF the indicator LED for Track 6
      }
    }
  }
  digitalWrite(Led_outTrack6, Led_stTrack6);                          //write the LED Status for Track 6 indicator LED
  Indicator_stTrack6Pre = Indicator_stTrack6Act;                      //write current Track status in previous Track statu variable 

 // ################### Indicator control Track 7: ####################

 if (Indicator_stTrack7Act != Indicator_stTrack7Pre) {               // check if status of occopancy on Track 7 has changed
    Time_tilast7 = millis();                                          // Write actual time in Time_tilast7
  }
  if ((millis() - Time_tilast7) > DebouncingTime) {                   // check if debouncing time to change LED status is elapsed
    if (Indicator_stTrack7Act != Indicator_stTrack7) {                // check if occopancy status change of Track 7 is still present after debouncing time 
      Indicator_stTrack7 = Indicator_stTrack7Act;
      if (Indicator_stTrack7 == LOW) {                                 //check if Track 7 is occupied
        Led_stTrack7 = HIGH;                                          // switch ON the indicator LED for Track 7
      }
      if (Indicator_stTrack7 == HIGH) {                                //check if Track 7 is free
        Led_stTrack7 = LOW;                                           // switch OFF the indicator LED for Track 7
      }
    }
  }
  digitalWrite(Led_outTrack7, Led_stTrack7);                          //write the LED Status for Track 7 indicator LED
  Indicator_stTrack7Pre = Indicator_stTrack7Act;                      //write current Track status in previous Track statu variable 

}
